function gadget:GetInfo()
  return {
    name      = "fog_layer",
    desc      = "draws fog layers",
    author    = "raaar",
    date      = "2018",
    license   = "pd",
    layer     = 0,
    enabled   = true
  }
end

local spGetGameSeconds = Spring.GetGameSeconds
local sin = math.sin
local cos = math.cos
local abs = math.abs
local pi = math.pi

local FOG_ALPHA = 0.14
local FOG_BG_COLOR = {0.1,0.15,0.2}
local FOG_COLOR = {0.8,0.9,1.0}

local periodMult = 2
local OFFSETS_1 = {0.0,0.0}
local OFFSETS_2 = {0.3,0.1}
local OFFSETS_3 = {0.13,-0.2}
local OFFSETS_4 = {-0.2,-0.2}
local OFFSETS_5 = {0.2,-0.2}
local OFFSETS_6 = {-0.2,0.2}

local x = Game.mapSizeX*1.5
local z = Game.mapSizeZ*1.5
 

------------------------------------ SYNCED
if (gadgetHandler:IsSyncedCode()) then


------------------------------------ UNSYNCED
else

function gadget:DrawWorldPreUnit ()  
	drawPlane(20,1,9*periodMult,3,OFFSETS_1,FOG_BG_COLOR,1)
	drawPlane(50,5,13.3*periodMult,2.1,OFFSETS_2,FOG_COLOR,FOG_ALPHA)
	drawPlane(80,4,11.65*periodMult,10,OFFSETS_3,FOG_COLOR,FOG_ALPHA)
	drawPlane(110,1.8,15.8*periodMult,3.3,OFFSETS_4,FOG_COLOR,FOG_ALPHA)
	drawPlane(140,7,33.2*periodMult,4.7,OFFSETS_5,FOG_COLOR,FOG_ALPHA)
	drawPlane(170,2.6,48.7*periodMult,1.9,OFFSETS_6,FOG_COLOR,FOG_ALPHA)
end


function drawPlane (y,scaleFactor,periodS,tOffset,offsets,color,alpha)
	local t = spGetGameSeconds()
	scaleFactor = scaleFactor * (1+sin(2*pi*(t+tOffset)/periodS) / 15)
	offsetMult = 0.6*(1+sin(2*pi*(t+tOffset)/(0.8*periodS)) / 1)
	
	gl.PushAttrib(GL.ALL_ATTRIB_BITS)
	gl.DepthTest(true)
	gl.DepthMask(true)	
	gl.Texture(0,":a:LuaRules\\Images\\fog.png")-- Texture file	
	gl.Texture(1,":a:LuaRules\\Images\\fog.png")-- Texture file	
	--gl.Color(red,green,blue,alpha)	
	gl.Color(color[1],color[2],color[3],alpha)
	gl.BeginEnd(GL.QUADS,drawPlaneVertexes,  y,scaleFactor, offsets, offsetMult)
	gl.Texture(false)
	gl.DepthMask(false)
	gl.DepthTest(false)	
	gl.PopAttrib()
end



function drawPlaneVertexesOLD (y,scaleFactor, offsets, offsetMult)
  local s = scaleFactor
 
--gl.Texture(0,fogtex)
--gl.Texture(1,fogtex)

  gl.MultiTexCoord(0,-s,-s)
  gl.MultiTexCoord(1,-s*2.3,-s*2.3)
  gl.Vertex(-x *(1+offsets[1]*offsetMult),y, -z*(1+offsets[2]*offsetMult))
 
  gl.MultiTexCoord(0,-s,s)
  gl.MultiTexCoord(1,-s*2.3,s*2.3)
  gl.Vertex(-x*(2+offsets[1]*offsetMult),y,z*(2+offsets[2]*offsetMult))
 
  gl.MultiTexCoord(0,s,s)
  gl.MultiTexCoord(1,s*2.3,s*2.3)
  gl.Vertex(x*(2+offsets[1]*offsetMult),y,z*(2+offsets[2]*offsetMult))
 
  gl.MultiTexCoord(0,s,-s)
  gl.MultiTexCoord(1,s*2.3,-s*2.3)
  gl.Vertex(x*(2+offsets[1]*offsetMult),y,-z*(1+offsets[2]*offsetMult))
 
end

function drawPlaneVertexes (y,scaleFactor, offsets, offsetMult)
  local s = scaleFactor
 
--gl.Texture(0,fogtex)
--gl.Texture(1,fogtex)

  gl.MultiTexCoord(0,-s,-s)
  gl.MultiTexCoord(1,-s*2.3,-s*2.3)
  gl.Vertex(-x *(1+offsets[1]*offsetMult),y, -z*(1+offsets[2]*offsetMult))
 
  gl.MultiTexCoord(0,-s,s)
  gl.MultiTexCoord(1,-s*2.3,s*2.3)
  gl.Vertex(-x*(2+offsets[1]*offsetMult),y,z*(2+offsets[2]*offsetMult))
 
  gl.MultiTexCoord(0,s,s)
  gl.MultiTexCoord(1,s*2.3,s*2.3)
  gl.Vertex(x*(2+offsets[1]*offsetMult),y,z*(2+offsets[2]*offsetMult))
 
  gl.MultiTexCoord(0,s,-s)
  gl.MultiTexCoord(1,s*2.3,-s*2.3)
  gl.Vertex(x*(2+offsets[1]*offsetMult),y,-z*(1+offsets[2]*offsetMult))
 
end

end 