function gadget:GetInfo()
   return {
      name = "Void Handler",
      desc = "Removes objects that fall into the void",
      author = "raaar",
      date = "2018",
      license = "PD",
      layer = -10,
      enabled = true,
   }
end


-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------

if (not gadgetHandler:IsSyncedCode()) then
    return
end


local spGetUnitPosition = Spring.GetUnitPosition
local spGetAllUnits = Spring.GetAllUnits
local spDestroyUnit = Spring.DestroyUnit
local spGetAllFeatures = Spring.GetAllFeatures
local spDestroyFeature = Spring.DestroyFeature
local spGetFeaturePosition = Spring.GetFeaturePosition
local spGetProjectilesInRectangle = Spring.GetProjectilesInRectangle
local spGetProjectilePosition = Spring.GetProjectilePosition
local spDeleteProjectile = Spring.DeleteProjectile
local VOID_HEIGHT_THRESHOLD = 20


-- remove objects that fell into the void
-- also prevent terraform units if over void
function gadget:GameFrame(n)
	
	-- units
	local x,y,z
	for _,uId in pairs(spGetAllUnits()) do
		x,y,z = spGetUnitPosition(uId)
		if (y and y < VOID_HEIGHT_THRESHOLD) then
			spDestroyUnit(uId,false,true)
		end
	end
	
	-- features
	for _,fId in pairs(spGetAllFeatures()) do
		x,y,z = spGetFeaturePosition(fId)
		if (y and y < VOID_HEIGHT_THRESHOLD) then
			spDestroyFeature(fId)
		end
	end

	-- projectiles
	for _,pId in pairs(spGetProjectilesInRectangle(0,0,Game.mapSizeX,Game.mapSizeZ)) do
		x,y,z = spGetProjectilePosition(pId)
		if (y and y < VOID_HEIGHT_THRESHOLD) then
			spDeleteProjectile(pId)
		end
	end
end
