--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- mapinfo.lua
--

local mapinfo = {
	name        = "Hexian Arena",
	shortname   = "hexianarena",
	description = "Dispute the center or sneak along the edges of this hexian battle ground. East vs West recommended. 2-6 players.",
	author      = "raaar",
	version     = "v4",
	--mutator   = "deployment";
	mapfile   = "maps/hexianarena.smf", --// location of smf/sm3 file (optional)
	modtype     = 3, --// 1=primary, 0=hidden, 3=map
	depend      = {},
	replace     = {},

	--startpic   = "", --// deprecated
	--StartMusic = "", --// deprecated

	maphardness     = 700,
	notDeformable   = false,
	gravity         = 130,
	tidalStrength   = 0,
	maxMetal        = 6.00,
	extractorRadius = 100.0,
	voidWater       = true,
	autoShowMetal   = true,


	smf = {
		minheight = -100,
		maxheight = 900,
		smtFileName0 = "maps/hexianarena.smt",
		--minimapTex = "maps/minimap.png",
		--smtFileName1 = "",
		--smtFileName.. = "",
		--smtFileNameN = "",
	},

	sound = {
		--// Sets the _reverb_ preset (= echo parameters),
		--// passfilter (the direct sound) is unchanged.
		--//
		--// To get a list of all possible presets check:
		--//   https://github.com/spring/spring/blob/master/rts/System/Sound/EFXPresets.cpp
		--//
		--// Hint:
		--// You can change the preset at runtime via:
		--//   /tset UseEFX [1|0]
		--//   /tset snd_eaxpreset preset_name   (may change to a real cmd in the future)
		--//   /tset snd_filter %gainlf %gainhf  (may    "   "  "  "    "  "   "    "   )
		preset = "default",

		passfilter = {
			--// Note, you likely want to set these
			--// tags due to the fact that they are
			--// _not_ set by `preset`!
			--// So if you want to create a muffled
			--// sound you need to use them.
			gainlf = 1.0,
			gainhf = 1.0,
		},

		reverb = {
			--// Normally you just want use the `preset` tag
			--// but you can use handtweak a preset if wanted
			--// with the following tags.
			--// To know their function & ranges check the
			--// official OpenAL1.1 SDK document.
			
			--density
			--diffusion
			--gain
			--gainhf
			--gainlf
			--decaytime
			--decayhflimit
			--decayhfratio
			--decaylfratio
			--reflectionsgain
			--reflectionsdelay
			--reflectionspan
			--latereverbgain
			--latereverbdelay
			--latereverbpan
			--echotime
			--echodepth
			--modtime
			--moddepth
			--airabsorptiongainhf
			--hfreference
			--lfreference
			--roomrollofffactor
		},
	},

	resources = {
		--grassBladeTex = "",

		--grassShadingTex = "",
		detailTex = "maps/detailtex.bmp",
		specularTex = "maps/speculartex.dds",
		--splatDetailTex = "",
		--splatDistrTex = "",
		--skyReflectModTex = "",
		--detailNormalTex = "",
		--lightEmissionTex = "",
	},

	splats = {
		texScales = {0.02, 0.02, 0.02, 0.02},
		texMults  = {1.0, 1.0, 1.0, 1.0},
	},

	atmosphere = {
		minWind      = 5.0,
		maxWind      = 20.0,

		fogStart     = 0.1,
		fogEnd       = 1.0,
		fogColor     = {0.4, 0.5, 0.6},

		sunColor     = {1.0, 1.0, 1.0},
		skyColor     = {0.7, 0.75, 0.8},
		skyDir       = {0.0, 0.0, -10.0},
		skyBox       = "",

		cloudDensity = 0.8,
		cloudColor   = {1.0, 1.0, 1.0},
	},

	grass = {
		bladeWaveScale = 1.0,
		bladeWidth  = 0.32,
		bladeHeight = 4.0,
		bladeAngle  = 1.57,
		bladeColor  = {0.59, 0.81, 0.57}, --// does nothing when `grassBladeTex` is set
	},

	lighting = {
		--// dynsun
		sunStartAngle = 0.0,
		sunOrbitTime  = 1440.0,
		sundir        = { -0.2, 0.25, -0.4 },

		--// unit & ground lighting
		groundAmbientColor  = {0.65, 0.65, 0.65},
		groundDiffuseColor  = {0.65, 0.65, 0.65},
		groundSpecularColor = {0.2, 0.2, 0.2},
		groundShadowDensity = 0.8,
		unitAmbientColor    = {0.4, 0.4, 0.4},
		unitDiffuseColor    = {0.7, 0.7, 0.7},
		unitSpecularColor   = {0.7, 0.7, 0.7},
		unitShadowDensity   = 0.8,
		
		specularExponent    = 100.0,
	},
	
	
	water = {
		damage =  100000.0,

		repeatX = 0.0,
		repeatY = 0.0,

		absorb    = {0.0, 0.0, 0.0},
		baseColor = {0.11, 0.11, 0.11},
		minColor  = {0.11, 0.11, 0.11},

		ambientFactor  = 0.0,
		diffuseFactor  = 0.0,
		specularFactor = 0.0,
		specularPower  = 20.0,

		planeColor = {0.1, 0.1, 0.1},

		surfaceColor  = {0.1, 0.1, 0.1},
		surfaceAlpha  = 0.0,
		diffuseColor  = {0.1, 0.1, 0.1},
		specularColor = {0.1, 0.1, 0.1},

		fresnelMin   = 0.2,
		fresnelMax   = 0.8,
		fresnelPower = 4.0,

		reflectionDistortion = 1.0,

		blurBase      = 2.0,
		blurExponent = 1.5,

		perlinStartFreq  =  8.0,
		perlinLacunarity = 3.0,
		perlinAmplitude  =  0.9,
		windSpeed = 1.0, --// does nothing yet

		shoreWaves = false,
		forceRendering = false,

		--// undefined == load them from resources.lua!
		--texture =       "",
		--foamTexture =   "",
		--normalTexture = "",
		--caustics = {
		--	"",
		--	"",
		--},
	},

	teams = {
		[0] = {startPos = {x = 2370, z = 5120}},		-- w
		[2] = {startPos = {x = 2370, z = 5120+1600}},		-- w2
		[4] = {startPos = {x = 2370, z = 5120-1600}},		-- w3
		
		[1] = {startPos = {x = 10240-2370, z = 5120}},	-- e
		[3] = {startPos = {x = 10240-2370, z = 5120+1600}},	-- e2
		[5] = {startPos = {x = 10240-2370, z = 5120-1600}},	-- e3

	},

	terrainTypes = {
		[0] = {
			name = "Ground",
			hardness = 1.0,
			receiveTracks = true,
			moveSpeeds = {
				tank  = 1.0,
				kbot  = 1.0,
				hover = 1.0,
				ship  = 1.0,
			},
		},
		[255] = {
			name = "Void",
			hardness = 1000000000.0,
			receiveTracks = false,
			moveSpeeds = {
				tank  = 0.0,
				kbot  = 0.0,
				hover = 0.0,
				ship  = 0.0,
			},
		},	
	},

	custom = {
		zkminwindmult = 0.3,
		fog = {
			color    = {1.0, 1.0, 1.0},
			height   = "30%", --// allows either absolute sizes or in percent of map's MaxHeight
			fogatten = 0.003, -- 0.003
		},
	},
}

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Helper

local function lowerkeys(ta)
	local fix = {}
	for i,v in pairs(ta) do
		if (type(i) == "string") then
			if (i ~= i:lower()) then
				fix[#fix+1] = i
			end
		end
		if (type(v) == "table") then
			lowerkeys(v)
		end
	end
	
	for i=1,#fix do
		local idx = fix[i]
		ta[idx:lower()] = ta[idx]
		ta[idx] = nil
	end
end

lowerkeys(mapinfo)

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Map Options

if (Spring and Spring.GetMapOptions) then
	local function tmerge(t1, t2)
		for i,v in pairs(t2) do
			if (type(v) == "table") then
				t1[i] = t1[i] or {}
				tmerge(t1[i], v)
			else
				t1[i] = v
			end
		end
	end

	getfenv()["mapinfo"] = mapinfo
		local files = VFS.DirList("mapconfig/mapinfo/", "*.lua")
		table.sort(files)
		for i=1,#files do
			local newcfg = VFS.Include(files[i])
			if newcfg then
				lowerkeys(newcfg)
				tmerge(mapinfo, newcfg)
			end
		end
	getfenv()["mapinfo"] = nil
end

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

return mapinfo

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
